#ifndef INVENTORYUSE_PLAYER_HEAL_H_INCLUDED
#define INVENTORYUSE_PLAYER_HEAL_H_INCLUDED

#include "ScriptPolicies.h"

#include "AIFuncionArgs.h"
#include "ScriptAIUtil.h"
#include "SPU_AIInstr_structs.h"

namespace ScriptProxies
{
    static eCScriptProxyScript ResumePlayerTask("ResumePlayerTask");
    static eCScriptProxyScript HealParty("HealParty");
}

template<int HealAmount, int HealTypeIndex>
struct InventoryUse_Player_Heal
{
    static GEBool GE_STDCALL Impl(bTObjStack<gScriptRunTimeSingleState>& SRTSSStack, gCScriptProcessingUnit* SPU)
    {
        Entity Self;
        Entity Other;
        GEInt Arg = 0;
        GELPByte __FIXME_0014 = reinterpret_cast<GELPByte>(SRTSSStack[SRTSSStack.GetCount() - 1].__FIXME_0014);

        if(__FIXME_0014)
        {
            Self.AttachTo(  reinterpret_cast<eCEntityProxy*>(__FIXME_0014 + 0x04)->GetEntity());
            Other.AttachTo( reinterpret_cast<eCEntityProxy*>(__FIXME_0014 + 0x10)->GetEntity());
            Arg = *reinterpret_cast<GEInt*>(__FIXME_0014 + 0x0C);
        }


        FIRST_SUBTASK
        {
            SET_SUBTASK_DONE;

            gui2.Open(gEHudPage_Game);
            gui2.RestoreUserPageMode();

            Entity Item = Other.GetPropertySet<PSInventory>().GetTemplateItem(Arg);
            Item.AccessPropertySet<PSCastInfo>().Consume(Other, Arg);

            ScriptProxies::HealParty(Other, NULL, HealAmount);

            const bCString* ActionStrings[3] = {&g_strAction_MinorHeal, &g_strAction_MediumHeal, &g_strAction_Heal};
            bCString Ani = Other.GetOverlayAni(*ActionStrings[HealTypeIndex], g_strPhase_Begin, gEDirection_Fwd, GEFalse, gECombatPose_P0);
            CAIPlayAniInstr AIPlayAniInstr(Other, 0, Ani, 0, GEFalse, 1.0, GEFalse, GETrue, GEFalse);
            if(!gCScriptProcessingUnit::sAIPlayAniInstr(&AIPlayAniInstr, SPU, GEFalse))
                return GEFalse;
        }

        NEXT_SUBTASK
        {
            SET_SUBTASK_DONE;
            
            ScriptProxies::ResumePlayerTask(Other, 0, 0);
        }

        return GETrue;
    }
};

#endif